﻿using System.Collections.Generic;
using Infragistics.Controls.Editors;

namespace WpfApp2
{
    public class PropertyGenerator : PropertyGeneratorBase
    {
        public override List<PropertyGridPropertyItem> GenerateProperties(object forObject, PropertyGenerationOptions generationOptions, PropertyGridPropertyItem forPropertyItem)
        {
            var result = new List<PropertyGridPropertyItem>();

            if (forObject is IList<IDetailsViewModel> packetDetailsList)
            {
                CreateItems(packetDetailsList, result);
            }
            else if (forObject is ICollection<IPropertyViewModel> properties)
            {
                foreach (var property2 in properties)
                {
                    ProcessProperty(property2, null, result);
                }
            }

            return result;
        }

        private static void CreateItems(IList<IDetailsViewModel> packetDetailsList, List<PropertyGridPropertyItem> result)
        {
            foreach (var packetDetails in packetDetailsList)
            {
                foreach (var property in packetDetails.Properties)
                {
                    ProcessProperty(property, packetDetails.Name, result);
                }
            }
        }

        private static void ProcessProperty(IPropertyViewModel property, string category, List<PropertyGridPropertyItem> result)
        {
            if (property.Properties.Count > 0)
            {
                var item = new PropertyGridPropertyItem(property, nameof(IPropertyViewModel.Properties), category, typeof(IPropertyViewModel), true, false)
                {
                    DisplayName = property.Name
                };
                
                result.Add(item);
            }
            else
            {
                result.Add(new PropertyGridPropertyItem(property, nameof(IPropertyViewModel.Value), category, property.ValueType, false, false)
                {
                    DisplayName = property.Name
                });
            }
        }
    }
}